Bug 88702 - The orca screen reader no longer announces information about bold, italic, and underline
Summary: The orca screen reader no longer announces information about bold, italic, an...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
4.5.0.0.alpha0+ Master
Hardware: Other Linux (All)
: medium normal
Assignee: Niklas Johansson
QA Contact:
URL: http://nabble.documentfoundation.org/...
Whiteboard:
Keywords: accessibility
Depends on:
Blocks: a11y-Linux
  Show dependency treegraph
 
Reported: 2015-01-22 13:39 UTC by am_dxer
Modified: 2016-04-20 16:27 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description am_dxer 2015-01-22 13:39:47 UTC
IN libreoffice 4.2, when I pressed the keyboard shortcuts for bold, italic, or underline, orca would say bold on, underline on, or italic on. I could also position my cursor over text and press f6 to move to the styles and formatting area and when I tabbed from there, I would land on controls that would say bold, italic, and underline. After saying the control name, orca would say on or off which allowed me to determine attributes applied to text. In libreoffice writer, 4.3 and master, the state of these buttons doesn't seem to be communicated to orca as they always show that they are off  after using the keyboard shortcuts and then moving to the controls with f6 and the tab key. Orca also no longer speaks that attribute change when the keyboard shortcuts are used to toggle their status. Someone with vision told me that the state of the buttons changed visually when using the keyboard shortcuts to toggle the state of these text attributes.
Comment 1 Niklas Johansson 2015-01-23 20:50:44 UTC
I can verify the problem that the toggle buttons always seem to be set to off which clearly is a bug.

Note that you can find out if the text at the current position is bold, italic and so on by querying text formatting. Normally that is done by the key combination Orca + F. 

I'll try to find some time to look at this as soon as possible and get back here with what I find.
Comment 2 Niklas Johansson 2015-01-26 21:15:42 UTC
I think I have found the problem and possible solutions, but I need to verify and try to figure out what solution is best.
Comment 3 Niklas Johansson 2015-01-27 10:48:06 UTC
Should be fixed in the master branch now. I did some quick testing on Fedora and Windows which seems to work as expected on the platform. Need to look at Mac as well before I back port the patch towards the branches 4.4 and 4.3.

http://cgit.freedesktop.org/libreoffice/core/commit/?id=9b7b1774459edb93f2d3a11b2441851f4355a613
Comment 4 am_dxer 2015-01-28 05:31:23 UTC
I tested the master branch with this fix. For me, orca speakss whether bold, italic, or underline is on or off as I use keyboard shortcuts to enable and disable the text styles, however, if I move to the toolbar with f6 and tab to the attribute such as bold, italic or underline, orca says the attribute is turned off. When the control on the toolbar gains focus, it appears to disable the style in the document as when I return to the document, the orca "get current attributes" command no longer mentions the style being applied.
Comment 5 Niklas Johansson 2015-01-29 09:57:21 UTC
So there are multiple bugs here, all of which I can reproduce before the patch. 

The most important to what you wrote is:

Press Ctrl+B and then 
press F6 to go to the Formatting and Styles toolbar and then tab.
When the focus leaves Apply Style combo box text attribute is reset, in this case "bold" is no longer bold.
Comment 6 am_dxer 2015-01-29 19:09:24 UTC
Correct. I found something else today as I was doing some experimentation. If I use orca's screen review feature "flat review" on the toolbar, I can see that the bold button is pressed if my cursor is on bold text in the document. It seems that actually focusing the bold control with tab is what is causing it to be disabled.
Comment 7 am_dxer 2015-01-29 19:12:03 UTC
I forgot to mention, this flat review functionality only correctly reports the style if I use a version of master with the patch applied posted earlier in this bug report.
Comment 8 Robinson Tryon (qubit) 2015-12-10 03:37:43 UTC
Migrating Whiteboard tags to Keywords: (a11y -> accessibility)
Comment 9 Alex ARNAUD 2016-04-20 16:27:37 UTC
I've tried on LibreOffice 5.1.1 and it seems fixed. I mark the bug as "resolved". If you are able to reproduce them with latest LibreOffice version please re-open it.